Subject: Re: [PATCH v1] ethtool: provide UAPI for PHY master/slave configuration.

From: Russell King - ARM Linux admin <[email-masked]>
Date: Fri, 17 Apr 2020 12:51:13 +0100

On Fri, Apr 17, 2020 at 01:28:30PM +0200, Oleksij Rempel wrote:
> On Fri, Apr 17, 2020 at 11:11:45AM +0100, Russell King - ARM Linux admin wrote:
> > On Wed, Apr 15, 2020 at 11:57:39PM +0200, Andrew Lunn wrote:
> > > > diff --git a/drivers/net/phy/phy_device.c b/drivers/net/phy/phy_device.c
> > > > index c8b0c34030d32..d5edf2bc40e43 100644
> > > > --- a/drivers/net/phy/phy_device.c
> > > > +++ b/drivers/net/phy/phy_device.c
> > > > @@ -604,6 +604,7 @@ struct phy_device *phy_device_create(struct mii_bus *bus, int addr, u32 phy_id,
> > > >  	dev->asym_pause = 0;
> > > >  	dev->link = 0;
> > > >  	dev->interface = PHY_INTERFACE_MODE_GMII;
> > > > +	dev->master_slave = PORT_MODE_UNKNOWN;
> > > 
> > > phydev->master_slave is how we want the PHY to be configured. I don't
> > > think PORT_MODE_UNKNOWN makes any sense in that contest. 802.3 gives
> > > some defaults. 9.12 should be 0, meaning manual master/slave
> > > configuration is disabled. The majority of linux devices are end
> > > systems. So we should default to a single point device. So i would
> > > initialise PORT_MODE_SLAVE, or whatever we end up calling that.
> > 
> > I'm not sure that is a good idea given that we use phylib to drive
> > the built-in PHYs in DSA switches, which ought to prefer master mode
> > via the "is a multiport device" bit.
> > 
> > Just to be clear, there are three bits that configure 1G PHYs, which
> > I've framed in briefer terminology:
> > 
> > - 9.12: auto/manual configuration (1= manual 0= slave)
> > - 9.11: manual master/slave configuration (1= master, 0 = slave)
> > - 9.10: auto master/slave preference (1= multiport / master)
> > 
> > It is recommended that multiport devices (such as DSA switches) set
> > 9.10 so they prefer to be master.
> > 
> > It's likely that the reason is to reduce cross-talk interference
> > between neighbouring ports both inside the PHY, magnetics and the
> > board itself. I would suspect that this becomes critical when
> > operating at towards the maximum cable length.
> > 
> > I've checked some of my DSA switches, and 9.10 appears to default to
> > one, as expected given what's in the specs.
> 
> Hm..
> I've checked one of my DSA devices and 9.10 is by default 0 (proffered
> slave). It get slave even if it is preferred master and it is
> connected to a workstation (not multiport device) with a e1000e NIC.
> The e1000e is configured by default as preferred master.
> 
> Grepping over current linux kernel I see following attempts to
> configure master/slave modes:
> drivers/net/ethernet/intel/e1000e/phy.c:597
>   e1000_set_master_slave_mode()
> 
> all intel NICs have similar code code and do not touch preferred bit
> 9.10. Only force master/slave modes. So the preferred master is probably
> PHY defaults, bootstrap or eeprom.
> 
> drivers/net/ethernet/broadcom/tg3.c
> this driver seems to always force master mode
> 
> drivers/net/phy/broadcom.c:39
> if ethernet controller is BCMA_CHIP_ID_BCM53573 and the PHY is PHY_ID_BCM54210E
> then force master mode.
> 
> drivers/net/phy/micrel.c:637
> Force master mode if devicetree property is set: micrel,force-master
> 
> drivers/net/phy/realtek.c:173
> 	/* RTL8211C has an issue when operating in Gigabit slave mode * 
> 	return phy_set_bits(phydev, MII_CTRL1000,
> 		CTL1000_ENABLE_MASTER | CTL1000_AS_MASTER)

Short of working around hardware issues, I wonder whether some of the
above is due to not reading or understanding the 802.3 recommendation.
However, it is just a recommendation, not a requirement.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTC broadband for 0.8mile line in suburbia: sync at 10.2Mbps down 587kbps up